app/urls.py
from django.urls import path,include
from .views import *

urlpatterns = [
    path("index/",show),
    path("add/", addStudent),
    path('edit/<int:id>', edit),
    path('update/<int:id>',update),
    path('delete/<int:id>',destroy)  
]

students/urls.py
from django.contrib import admin
from django.urls import path,include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('app.urls')),
]

app/models.py
from django.db import models

 


# Create your models here.
class Student(models.Model):    
    name = models.CharField(max_length=100)  
    email = models.EmailField()  
    password = models.CharField(max_length=15)  
    class Meta:  
        db_table = "employee"  

app/forms.py
from django import forms 
from django.core.exceptions import ValidationError 
from .models import Student 

 
class StudentForm(forms.ModelForm):  
    class Meta:  
        model = Student  
        fields = "__all__"  
        
    def clean_password(self):
        value = self.cleaned_data.get('password')
        if len(value) < 5 or len(value) > 15:
            raise ValidationError("Password length should be between 5 and 15 characters.")
        return value
    

app/views.py
from django.shortcuts import render,redirect
from .forms import StudentForm
from .models import Student
# Create your views here.
def show(request):  
    students = Student.objects.all()  
    return render(request,"show.html",{'students':students})  

def addStudent(request):  
    if request.method == "POST": 
        form = StudentForm(request.POST)  
        if form.is_valid():
            try:  
                form.save()  
                return redirect('/index')  
            except:  
                pass  
    else:  
        form = StudentForm()  
    return render(request,'addStudent.html',{'form':form})    


def edit(request, id):  
    student = Student.objects.get(id=id)  
    return render(request,'edit.html', {'student':student})  


def update(request, id):  
    student = Student.objects.get(id=id)  
    form = StudentForm(request.POST, instance = student)  
    if form.is_valid():  
        form.save()  
        return redirect("/index")  
    return render(request, 'edit.html', {'student': student}) 

def destroy(request, id):  
    student = Student.objects.get(id=id)  
    student.delete()  
    return redirect("/index")  
 

app/templates/addStudent.html
{% extends "common.html" %} {% block content %}
<div class="outerdiv">
  <div class="formstyle">
    <form method="POST" align="center" class="post-form" action="">
      {% csrf_token %}
      <div class="container">
        <br />
        <div class="form-group row">
          <label class="col-sm-1 col-form-label"></label>
          <div class="col-sm-4">
            {% filter upper %}
            <h3>Enter Student Details</h3>
            {% endfilter %}
          </div>
        </div>
        <div class="form-group row">
          <label align="left" class="col-sm-2 col-form-label"
            >Student Name:</label
          >
          <div class="col-sm-4">{{ form.name }}</div>
        </div>
        <div class="form-group row">
          <label class="col-sm-2 col-form-label">Student Email:</label>
          <div class="col-sm-4">{{ form.email }}</div>
        </div>
        <div class="form-group row">
          <label class="col-sm-2 col-form-label">Student Password:</label>
          <div class="col-sm-4">{{ form.password }}</div>
        </div>
        <div class="form-group row">
          <label class="col-sm-1 col-form-label"></label>
          <div class="col-sm-4">
            <button type="submit" class="btn btn-primary">Submit</button>
          </div>
        </div>
      </div>
    </form>
  </div>
</div>
{% endblock content %}

app/templates/base.html
<p>Welcome to django templates</p>

app/templates/common.html
<!DOCTYPE html>
<html lang="en">
  <head>
    {% comment %} {% load bootstrap5 %}
    {% bootstrap_css %}
    {% bootstrap_javascript %} {% endcomment %}
    {% load static %}
    <link rel="stylesheet" href="{% static 'css/style.css' %}" />
    <meta charset="UTF-8" />
    <title>Index</title>
  </head>
  <body bgcolor="sky blue">
    {% include "base.html" %}
    {% include "header.html" %}
    {% block content %} 
    {% endblock content %}
    {% include "footer.html" %}
  </body>
</html>

app/templates/edit.html
<!DOCTYPE html>  
<html lang="en">  
<head>  
    <meta charset="UTF-8">  
    <title>Index</title>    
</head>  
<body>  
  {% include "base.html" %}
<form method="POST" class="post-form" action="/update/{{student.id}}">  
        {% csrf_token %}  
    <div class="container">  
<br>  
    <div class="form-group row">  
    <label class="col-sm-1 col-form-label"></label>  
    <div class="col-sm-4">  
    <h3>Update Details</h3>  
    </div>  
  </div>  
  </div>  
  <div class="form-group row">  
    <label class="col-sm-2 col-form-label">Student Name:</label>  
    <div class="col-sm-4">  
        <input type="text" name="name" id="id_name" required maxlength="100" value="{{ student.name }}" />  
    </div>  
  </div>  
    <div class="form-group row">  
    <label class="col-sm-2 col-form-label">Student Email:</label>  
    <div class="col-sm-4">  
        <input type="email" name="email" id="id_email" required maxlength="254" value="{{ student.email }}" />  
    </div>  
  </div>  
    <div class="form-group row">  
    <label class="col-sm-2 col-form-label">Student Password:</label>  
    <div class="col-sm-4">  
        <input type="text" name="password" id="id_password" required maxlength="15" value="{{ student.password }}" />  
    </div>  
  </div>  
    <div class="form-group row">  
    <label class="col-sm-1 col-form-label"></label>  
    <div class="col-sm-4">  
    <button type="submit" class="btn btn-success">Update</button>  
    </div>  
  </div>  
    </div>  
</form>  
</body>  
</html

app/templates/footer.html
<h1>this is footer</h1>

app/templates/header.html
<h1>this is header</h1>

app/templates/show.html
{% extends "common.html" %} 
{% block content %}
{% load custom_tags %}

<table border="1" class="table table-striped table-bordered table-sm">
  <thead class="thead-dark">
    <tr>
      <th>Student ID</th>
      <th>Student Name</th>
      <th>Student Email</th>
      <th>Student Password</th>
      <th>Actions</th>
    </tr>
  </thead>
  <tbody>
    {% if students %} 
    {% for student in students %}
    <tr>
      <td>{{ student.id }}</td>
      <td>{{ student.name|newString}}</td>
      <td>{{ student.email }}</td>
      <td>{{ student.password }}</td>
      <td>
        <a href="/edit/{{ student.id }}"
          ><span class="glyphicon glyphicon-pencil">Edit</span></a
        >
        <a href="/delete/{{ student.id }}"
          ><span class="glyphicon glyphicon-pencil">Delete</span></a
        >
      </td>
    </tr>
    {% endfor %} {% else %}
    <tr>
      <td colspan="5" align="center">No Record Found</td>
    </tr>
    {% endif %}
  </tbody>
</table>
<br />
<br />
<center><a href="/add" class="btn btn-primary">Add New Record</a></center>
{% endblock content %}